"""
Copyright 2008-2014 by Aerospike, Inc. All rights reserved.
THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE. THE COPYRIGHT NOTICE
ABOVE DOES NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION.
"""


# -*- coding: utf-8 -*-
from constants import *


class HandleSeedDown(object):

    def __call__(self, fn):

        def decorator(self, **kwargs):

            user = kwargs.get('user', None)
            password = kwargs.get('password', None)

            result = fn(self, user=user, password=password)
            if result != UNABLE_TO_CONNECT:
                self.set_status_on()
                return result

            seed = self.get_seed()
            for node in self._nodes:
                if node == seed:
                    continue
                ip, port = node.split(":")
                result = fn(self, ip, port, user=user, password=password)
                if result != UNABLE_TO_CONNECT:
                    self.set_seed(node)
                    self.set_status_on()
                    return result

            self.set_status_off()
            return UNABLE_TO_CONNECT

        return decorator
