"""
Copyright 2008-2014 by Aerospike, Inc. All rights reserved.
THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE. THE COPYRIGHT NOTICE
ABOVE DOES NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION.
"""


# -*- coding: utf-8 -*-
from flask import current_app
from constants import AMC_CONFIG_PATH
try:
    import ConfigParser as cp
except ImportError:
    import configparser as cp

class ConfigManager(object):

    _instance = None

    def __new__(cls, *args, **kwargs):
        if not cls._instance:
            cls._instance = super(ConfigManager, cls).__new__(
                                cls, *args, **kwargs)
            cls._instance.__init__()
        return cls._instance

    def __init__(self):
        self.update_interval = -1
        self._initialise_update_interval()

    def get_update_interval(self):

        return self.update_interval

    def _initialise_update_interval(self):

        try:
            config = cp.RawConfigParser()
            import sys
            if self.update_interval == -1:
                config.read(AMC_CONFIG_PATH)
                self.update_interval = config.getint('AMC', 'update_interval')
            return self.update_interval
        except Exception as e:
            return dict(update_interval="failure")

    def set_update_interval(self, update_interval):

        self.update_interval = int(update_interval)
        try:
            config = cp.RawConfigParser()
            #config.add_section('AMC')
            config.read(AMC_CONFIG_PATH)
            config.set('AMC', 'update_interval', update_interval)
            with open(AMC_CONFIG_PATH, 'wb') as configfile:
                config.write(configfile)
            return dict(status="success")
        except Exception:
            return dict(status="failure")


config_manager = ConfigManager()
